diff --git a/libstdc++-v3/acinclude.m4 b/libstdc++-v3/acinclude.m4
index 77569d5bb59..e7cbf0fcf96 100644
--- a/libstdc++-v3/acinclude.m4
+++ b/libstdc++-v3/acinclude.m4
@@ -5803,6 +5803,7 @@ AC_LANG_SAVE
   AC_TRY_COMPILE([
   #if defined(_WIN32) && !defined(__CYGWIN__)
   # include <stdint.h>
+  # include <stdio.h>
   # include <io.h>
   #endif
   ],[
@@ -5811,7 +5812,7 @@ AC_LANG_SAVE
     intptr_t crt_handle = _get_osfhandle(fd);
     void* win32_handle = reinterpret_cast<void*>(crt_handle);
   ], [ac_get_osfhandle=yes], [ac_get_osfhandle=no])
-  if test "$ac_objext" = yes; then
+  if test "$ac_get_osfhandle" = yes; then
     AC_DEFINE_UNQUOTED(_GLIBCXX_USE__GET_OSFHANDLE, 1,
       [Define if _get_osfhandle should be used for filebuf::native_handle().])
   fi
diff --git a/libstdc++-v3/config/io/basic_file_stdio.cc b/libstdc++-v3/config/io/basic_file_stdio.cc
index a33b53b3b27..f85b6e9be08 100644
--- a/libstdc++-v3/config/io/basic_file_stdio.cc
+++ b/libstdc++-v3/config/io/basic_file_stdio.cc
@@ -472,7 +472,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
     return _M_cfile;
 #elif _GLIBCXX_USE__GET_OSFHANDLE
     const intptr_t handle = _M_cfile ? _get_osfhandle(fileno(_M_cfile)) : -1;
-    return reinterpret_cast<native_handle>(handle);
+    return reinterpret_cast<native_handle_type>(handle);
 #else
     return fileno(_M_cfile);
 #endif
diff --git a/libstdc++-v3/configure b/libstdc++-v3/configure
index 5bed1fb8110..bef2b840a59 100755
--- a/libstdc++-v3/configure
+++ b/libstdc++-v3/configure
@@ -54476,6 +54476,7 @@ $as_echo_n "checking whether _get_osfhandle is defined in <io.h>... " >&6; }
 
   #if defined(_WIN32) && !defined(__CYGWIN__)
   # include <stdint.h>
+  # include <stdio.h>
   # include <io.h>
   #endif
 
@@ -54498,7 +54499,7 @@ else
   ac_get_osfhandle=no
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
-  if test "$ac_objext" = yes; then
+  if test "$ac_get_osfhandle" = yes; then
 
 cat >>confdefs.h <<_ACEOF
 #define _GLIBCXX_USE__GET_OSFHANDLE 1
diff --git a/libstdc++-v3/testsuite/27_io/basic_filebuf/native_handle/char/1.cc b/libstdc++-v3/testsuite/27_io/basic_filebuf/native_handle/char/1.cc
index 0551f260ade..3ab297ed6eb 100644
--- a/libstdc++-v3/testsuite/27_io/basic_filebuf/native_handle/char/1.cc
+++ b/libstdc++-v3/testsuite/27_io/basic_filebuf/native_handle/char/1.cc
@@ -17,8 +17,9 @@ using type = std::basic_filebuf<char>::native_handle_type;
 #if __has_include(<unistd.h>)
 # include <unistd.h> // close(int)
 #endif
-#if __has_include(<handleapi.h>)
-# include <handleapi.h> // CloseHandle(HANDLE)
+#if __has_include(<io.h>)
+# include <io.h> // _open_osfhandle
+# include <fcntl.h> // _O_RDONLY, _O_TEXT
 #endif
 
 #include <testsuite_hooks.h>
@@ -38,8 +39,8 @@ test01()
       ::close(handle); // POSIX
 #endif
 #if __has_include(<handleapi.h>)
-    else if constexpr (std::is_same_v<HandleT, void*>)
-      ::CloseHandle(handle); // Windows
+    else if constexpr (std::is_same_v<HandleT, void*>) // Windows
+      ::_close(::_open_osfhandle((intptr_t)handle, _O_RDONLY|_O_TEXT));
 #endif
     else
       VERIFY( false );
diff --git a/libstdc++-v3/testsuite/27_io/basic_filebuf/native_handle/wchar_t/1.cc b/libstdc++-v3/testsuite/27_io/basic_filebuf/native_handle/wchar_t/1.cc
index 7ee5e4e8f53..5917c3d29c6 100644
--- a/libstdc++-v3/testsuite/27_io/basic_filebuf/native_handle/wchar_t/1.cc
+++ b/libstdc++-v3/testsuite/27_io/basic_filebuf/native_handle/wchar_t/1.cc
@@ -10,8 +10,9 @@ using type = std::basic_filebuf<wchar_t>::native_handle_type;
 #if __has_include(<unistd.h>)
 # include <unistd.h> // close(int)
 #endif
-#if __has_include(<handleapi.h>)
-# include <handleapi.h> // CloseHandle(HANDLE)
+#if __has_include(<io.h>)
+# include <io.h> // _open_osfhandle
+# include <fcntl.h> // _O_RDONLY, _O_TEXT
 #endif
 
 #include <testsuite_hooks.h>
@@ -31,8 +32,8 @@ test01()
       ::close(handle); // POSIX
 #endif
 #if __has_include(<handleapi.h>)
-    else if constexpr (std::is_same_v<HandleT, void*>)
-      ::CloseHandle(handle); // Windows
+    else if constexpr (std::is_same_v<HandleT, void*>) // Windows
+      ::_close(::_open_osfhandle((intptr_t)handle, _O_RDONLY|_O_TEXT));
 #endif
     else
       VERIFY( false );